# Smallpower 6.4

## Description
The whole program dumps data from Beckhoff(using a PLC_configuration file .xlsx) and calculates real-time indicators(dumps them as well).
- the dumper should be started with :
```
./bin/start_dumper_smallpower.sh
```
Look at the status or kill the dumper with :
```
./bin/status_dumper_smallpower.sh
./bin/kill_dumper_smallpower.sh
```

- possible to work with the beckhoff simulator:
```
./bin/start_simulator_smallpower.sh
```

## pre-requisites

### postgresSQL
- postgressql server should be active running on port 5432(user:postgres,password:sylfenbdd) containing a **jules** database with a **realtimedata** table(default settings).
- do not forget to cofnigure pg_hba.conf correctly.
- you change password of user postgres with :
```shell
alter user <postgres> password '<newpassword>';
```  

### Connection to the beckhoff opcua server
- in order to be able to connect to the beckhoff for the dumping and real-time you should do the following or you have already take an existing certif/key pair:
```shell
openssl req -x509 -newkey rsa:4096 -keyout <key.pem> -out <cert.pem> -days 7200 -nodes
```

### data acquisition
- it uses the python package dorianUtils==6.4. Please install it with pip:
```
pip install dorianUtils==6.4
```
- data are dumped a in the folder ~/smallPower_daily by default.
- to change the default settings, create a file *parameters_conf.py* in the smallpower folder which will overwrite the default parameters from smallpower/conf.py. In that case you should install the project using:
```
pip install -e .
```
- a plc configuration file : ALPHA - BD Instrum XL_Vxxx.xlsm should be in the confFiles folder. The new version is to be put in the same folder if there are any updates.
- conf.py has a function generate_conf_small_power to regenerate the configuration and load the new configuration file. It builds also the tag_color_code and the list of indicators.
